#!/usr/bin/python
# -*- coding: utf-8 -*-

#---------------------------------#
#   att1ファイル表示スクリプト    #
#         PyDecoMail              #
#                                 #
#   for pys60 1.4.x or 1.9.x      #
#http://twitter.com/galleriapizza #
#---------------------------------#
# モジュール読込
import sys, os, re
import time
from stat import *
import appuifw, e32, globalui
appuifw.app.title = unicode("PyDecoMail", "utf-8")


# -------- #
# 初期設定 #
# -------- #
CONF = {}
# 設定ファイルパス
CONF['setting_file_path'] = ""
if os.path.isdir("E:\\DATA") == True:
    if os.path.isdir("E:\\DATA\\Galleria") == False:
        os.mkdir("E:\\DATA\\Galleria")
        if os.path.isdir("E:\\DATA\\Galleria") == True:
            CONF['setting_file_path'] = "E:\\DATA\\Galleria\\PyDecoMail.conf"
    else:
        CONF['setting_file_path'] = "E:\\DATA\\Galleria\\PyDecoMail.conf"

# 設定の読込
if os.path.isfile(CONF['setting_file_path']) == True:
    fileobj = open(CONF['setting_file_path'], "r")
    setting_text = fileobj.read()
    fileobj.close()
    setting_list = setting_text.split(',')
    # 検索ドライブ
    if len(setting_list[0]) > 0:
        CONF['setting_drive_name'] = setting_list[0]
    else:
        CONF['setting_drive_name'] = ""
        CONF['setting_drive'] = 0
    # 日数制限
    if len(setting_list[1]) > 0:
        CONF['setting_days'] = int(setting_list[1])
    else:
        CONF['setting_days'] = 2
    # ファイル数制限
    if len(setting_list[2]) > 0:
        CONF['setting_limit'] = int(setting_list[2])
    else:
        CONF['setting_limit'] = 2
    # ATT1調整方法
    if len(setting_list[3]) > 0:
        CONF['setting_att1'] = int(setting_list[3])
    else:
        CONF['setting_att1'] = 1
    # ﾀｲﾑｽﾀﾝﾌﾟ取得
    if len(setting_list[4]) > 0:
        CONF['setting_ts'] = int(setting_list[4])
    else:
        CONF['setting_ts'] = 1
    # ｿｰﾄ（ver1.9.x用）
    if len(setting_list[5]) > 0:
        CONF['setting_sort'] = int(setting_list[5])
    else:
        CONF['setting_sort'] = 1
else:
    # デフォルト設定
    CONF['setting_drive'] = 0
    CONF['setting_days'] = 2
    CONF['setting_limit'] = 2
    CONF['setting_att1'] = 1
    CONF['setting_ts'] = 1
    CONF['setting_sort'] = 1
    CONF['setting_drive_name'] = ""

# 検索ディレクトリの指定
CONF['mail_dir'] = ""
CONF['drives'] = []
drives = e32.drive_list()
drive_num = 0
for d in drives:
    if os.path.isdir(d + "\\Private\\1000484b\\Mail2\\00001001_S") == True:
        CONF['drives'].append(d)
        if CONF['setting_drive_name'] == d:
            CONF['mail_dir'] = d + "\\Private\\1000484b\\Mail2\\00001001_S"
            CONF['setting_drive'] = drive_num

        elif len(CONF['mail_dir']) == 0 and len(CONF['setting_drive_name']) == 0:
            CONF['mail_dir'] = d + "\\Private\\1000484b\\Mail2\\00001001_S"
        drive_num += 1

# マスタ情報（日数制限、ファイル制限）
DAYS_AGO_MASTER   = (0, 1, 3, 7, 14, 30)
FILE_LIMIT_MASTER = (0, 5, 10, 30, 50, 100)
CONF['app_path'] = os.getcwd() + "\\";

# hour_ago時間以内に作成されたatt1ファイルを収集
CONF['hour_ago'] = 24 * DAYS_AGO_MASTER[CONF['setting_days']]
# 取得ファイル数制限
CONF['file_limit'] = FILE_LIMIT_MASTER[CONF['setting_limit']]
# ソート実行判断（ver1.9.x系のみ）
if CONF['setting_sort'] >= 1:
    CONF['file_sort'] = True
else:
    CONF['file_sort'] = False

# ファイルの更新情報を取得するか
if CONF['setting_ts'] == 1:
    CONF['file_get_ts'] = True
else:
    CONF['file_get_ts'] = False


# ファイル更新日時比較用タイムスタンプ（グローバル）
CONF['check_ts'] = 0
# 該当ファイルパス保持用（グローバル）
ATT1_FILE_LIST = {}
# 該当ファイル更新日時保持用（グローバル）
ATT1_FILE_UPDATE = {}
# 該当ファイル数保持用（グローバル）
FILE_COUNT = 0
# 検索対象ファイル総数
FILE_TOTAL = 0


# pys60のバージョンが1.9.x系かチェック
if re.match("^1\.9\.", e32.pys60_version) == None:
    CONF['ver19']     = False
    CONF['file_sort'] = False
else:
    CONF['ver19'] = True

# 現在の時刻取得（タイムスタンプ）
start_ts = time.time()


# ---------- #
# 設定の保存 #
# ---------- #

def saveConfig():
    global CONF

    save_data = ""
    save_data = str(CONF['drives'][CONF['setting_drive']]) # 検索ドライブ
    save_data = save_data + "," + str(CONF['setting_days']) # 日数制限
    save_data = save_data + "," + str(CONF['setting_limit']) # ファイル数制限
    save_data = save_data + "," + str(CONF['setting_att1']) # ATT1調整方法
    save_data = save_data + "," + str(CONF['setting_ts']) # ﾀｲﾑｽﾀﾝﾌﾟ取得
    save_data = save_data + "," + str(CONF['setting_sort']) # ｿｰﾄ（ver1.9.x用）

    # ディレクトリチェック
    if os.path.isdir("E:\\DATA\\Galleria") == False:
        CONF['setting_file_path'] = ""

    if len(CONF['setting_file_path']) == 0:
        return False

    fileobj = open(CONF['setting_file_path'], "w")
    fileobj.write(save_data)
    fileobj.close()

# -------------------- #
# att1ファイル検索関数 #
# -------------------- #

def searchAtt1File(search_dir):

    # グローバル変数
    global FILE_COUNT, ATT1_FILE_LIST, ATT1_FILE_UPDATE, FILE_TOTAL, CONF

    # ディレクトリ内を検索開始
    if os.path.isdir(search_dir) == True:
        # ファイル名一覧取得（ディレクトリ名も含む）
        files = os.listdir(search_dir)
        # 取得した一覧から１つずつ抜き出す
        for filename in files:
            # ファイルパス作成
            if CONF['ver19'] == False:
                path_temp = search_dir + "\\" + unicode(filename, "utf-8")
            else:
                path_temp = search_dir + "\\" + filename
            # 0-9a-fまでの１文字ディレクトリの場合だけ掘り下げる
            if re.match("^([0-9a-f]{1})$", filename) != None:
                # この関数を呼び出す（１階層掘り下げて検索）
                if searchAtt1File(path_temp) == False:
                    return False
            # 添付ファイルがあるディレクトリではない
            elif re.match("(.*)_F$", filename) == None:
                FILE_TOTAL += 1
                # メールファイルの更新（作成）日時を取得
                file_ts = os.lstat(path_temp)[ST_MTIME]
                # 1.4.xではタイムスタンプが標準なので＋９時間
                if CONF['ver19'] == False:
                    file_ts += 32400
                if file_ts >= CONF['check_ts']:
                    # 添付ファイルディレクトリをチェック
                    if os.path.isfile(path_temp + "_F\\att1") == True:
                        ATT1_FILE_LIST[FILE_COUNT]   = unicode(path_temp + "_F\\att1") # ファイルパス
                        ATT1_FILE_UPDATE[FILE_COUNT] = unicode(time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(file_ts))) # ファイル更新（作成）日時
                        FILE_COUNT = FILE_COUNT + 1 # 該当ファイル数の加算
                        if CONF['file_limit'] > 0 and FILE_COUNT >= CONF['file_limit']:
                            return False

# -------------------- #
# att1ファイル検索関数 #
# 全ATT1取得用         #
# -------------------- #

def searchAtt1FileAll(search_dir, file_check=False):

    # グローバル変数
    global FILE_COUNT, ATT1_FILE_LIST, ATT1_FILE_UPDATE, FILE_TOTAL, CONF

    # ディレクトリ内を検索開始
    if os.path.isdir(search_dir) == True:
        # ファイル名一覧取得（ディレクトリ名も含む）
        files = os.listdir(search_dir)
        # 取得した一覧から１つずつ抜き出す
        for filename in files:
            # ファイルパス作成
            if CONF['ver19'] == False:
                path_temp = search_dir + "\\" + unicode(filename, "utf-8")
            else:
                path_temp = search_dir + "\\" + filename
            if file_check == True:
                FILE_TOTAL += 1
                # ファイル名が「att1」かチェック
                if filename.lower() == 'att1':
                    if CONF['file_get_ts'] == False:
                        ATT1_FILE_LIST[FILE_COUNT]   = unicode(path_temp) # ファイルパス
                        ATT1_FILE_UPDATE[FILE_COUNT] = unicode(FILE_COUNT+1) # ファイル更新（作成）日時
                        FILE_COUNT = FILE_COUNT + 1 # 該当ファイル数の加算
                        if CONF['file_limit'] > 0 and FILE_COUNT >= CONF['file_limit']:
                            return False
                    else:
                        # att1ファイルの更新（作成）日時を取得
                        file_ts = os.lstat(path_temp)[ST_MTIME]
                        # 1.4.xではタイムゾーンが標準なので＋９時間
                        if CONF['ver19'] == False:
                            file_ts += 32400
                        # 更新（作成）日時が、規定内であれば必要な情報を保持する
                        if file_ts >= CONF['check_ts'] or CONF['hour_ago'] == 0:
                            ATT1_FILE_LIST[FILE_COUNT]   = unicode(path_temp) # ファイルパス
                            ATT1_FILE_UPDATE[FILE_COUNT] = unicode(time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(file_ts))) # ファイル更新（作成）日時
                            FILE_COUNT = FILE_COUNT + 1 # 該当ファイル数の加算
                            if CONF['file_limit'] > 0 and FILE_COUNT >= CONF['file_limit']:
                                return False

            # 対象ディレクトリの場合だけ掘り下げる
            elif re.match("^([0-9a-f]{1})$", filename) != None:
                # この関数を呼び出す（１階層掘り下げて検索）
                if searchAtt1FileAll(path_temp, False) == False:
                    return False
            elif re.match("(.*)_F$", filename) != None:
                # この関数を呼び出す（att1検索対象として）
                if searchAtt1FileAll(path_temp, True) == False:
                    return False

        return True

# ------------ #
# 検索プロセス #
# ------------ #

def procSearch():

    # ------------------------------------ #
    # att1ファイル選択時に呼び出される関数 #
    # ------------------------------------ #

    def select_att1_file():
        key = listbox.current()
        if len(path_list[key]):
            show_att1_file(path_list[key])
        return True


    # ------------------------------------ #
    # att1ファイルをブラウザで表示する関数 #
    # 表示前にヘッダーをあわせてる         #
    # ------------------------------------ #

    def show_att1_file(file_path):
        global CONF
        # 調整なし
        if CONF['setting_att1'] == 0:
            e32.start_exe('BrowserNG.exe', ' "file:///'+ file_path +'"', 1)

        # ヘッダ調整
        elif CONF['setting_att1'] == 1:
            if os.path.isfile(file_path):
                # ファイルを開く
                fileobj = open(file_path, "rb")
                # ファイル内容読込み
                fileText = fileobj.read()
                # 文字列検索
                num = re.search("<HTML><HEAD><meta", fileText)
                fileobj.close()
                # 該当文字列がヒットすれば
                if num >= 0:
                    # att1と同じディレクトリに一時ファイル作成（ファイル名 = att1_temp）
                    fileobj = open(file_path + "_temp", "w")
                    fileobj.write(fileText[num.start():])
                    fileobj.close()
                    # 作成した一時ファイルをブラウザに渡す
                    e32.start_exe('BrowserNG.exe', ' "file:///'+ file_path + '_temp"', 1)
                # 該当なし（非HTML）
                else:
                    e32.start_exe('BrowserNG.exe', ' "file:///'+ file_path +'"', 1)

        # 拡張子調整
        elif CONF['setting_att1'] == 2:
            e32.file_copy(file_path + ".html", file_path)
            e32.start_exe('BrowserNG.exe', ' "file:///'+ file_path + '.html"', 1)

        # ヘッダ＆拡張子調整
        elif CONF['setting_att1'] == 3:
            if os.path.isfile(file_path):
                # ファイルを開く
                fileobj = open(file_path, "rb")
                # ファイル内容読込み
                fileText = fileobj.read()
                # 文字列検索
                num = re.search("<HTML><HEAD><meta", fileText)
                fileobj.close()
                # 該当文字列がヒットすれば
                if num >= 0:
                    # att1と同じディレクトリに一時ファイル作成（ファイル名 = att1_temp）
                    fileobj = open(file_path + ".html", "w")
                    fileobj.write(fileText[num.start():])
                    fileobj.close()
                else:
                    e32.file_copy(file_path + ".html", file_path)

                e32.start_exe('BrowserNG.exe', ' "file:///'+ file_path + '.html"', 1)

        return True

    # グローバル変数
    global FILE_COUNT, ATT1_FILE_LIST, ATT1_FILE_UPDATE, FILE_TOTAL, CONF

    # 変数初期化
    ATT1_FILE_LIST   = {}
    ATT1_FILE_UPDATE = {}
    FILE_TOTAL = 0
    FILE_COUNT = 0

    # 検索時間計測用
    search_ts = time.time()
    globalui.global_note(unicode("ATT1ファイルを検索中です...", "utf-8"), "info")

    # att1ファイル検索
    if CONF['file_get_ts'] == True and CONF['hour_ago'] > 0:
        searchAtt1File(CONF['mail_dir'])
    else:
        searchAtt1FileAll(CONF['mail_dir'])

    # 検索で取得したatt1ファイル一覧を
    # 更新日時の降順でソートしてリストに保持
    path_list   = [] # 保持用リスト（ファイルパス）
    update_list = [] # 保持用リスト（ファイル更新日時）
    att_file_count = 0

    if CONF['ver19'] == True and CONF['file_sort'] ==  True:
        # ソート（version1.9.x以上）
        # 降順
        if CONF['setting_sort'] == 1:
            for key, val in sorted(ATT1_FILE_UPDATE.items(), key=lambda x:str(x[1]), reverse=True):
                update_list.append(ATT1_FILE_UPDATE[key])
                path_list.append(ATT1_FILE_LIST[key])
                att_file_count += 1
        # 昇順
        else:
            for key, val in sorted(ATT1_FILE_UPDATE.items(), key=lambda x:str(x[1]), reverse=False):
                update_list.append(ATT1_FILE_UPDATE[key])
                path_list.append(ATT1_FILE_LIST[key])
                att_file_count += 1
    else:
        for key in ATT1_FILE_UPDATE.keys():
            update_list.append(ATT1_FILE_UPDATE[key])
            path_list.append(ATT1_FILE_LIST[key])
            att_file_count += 1

    # 該当件数と検索時間表示（テスト用）
    rtn = globalui.global_msg_query(unicode(str(FILE_TOTAL) + "ファイル中" + str(att_file_count) + "ファイル見つかりました。検索には" + str(int(time.time() - search_ts)) + "秒かかりました。", "utf-8"), unicode("結果", "utf-8"))
    if att_file_count > 0:
        # ファイル情報をリストボックスに渡して表示する
        listbox = appuifw.Listbox(update_list, select_att1_file)
        appuifw.app.body = listbox

    else:
        globalui.global_note(unicode("ファイルが見付かりませんでした", "utf-8"), "info")



# オプションMENU
lock = e32.Ao_lock()

# 検索開始
def search():
    global CONF
    # ファイル更新日時比較用タイムスタンプ（グローバル）
    CONF['check_ts'] = time.time() - (60 * 60 * CONF['hour_ago'])
    procSearch()

# 設定
def setting():
    global CONF
    form = appuifw.Form([
(unicode("対象ドライブ","utf-8"), "combo",(CONF['drives'], CONF['setting_drive'])),
(unicode("日数制限","utf-8"), "combo",([unicode("制限なし", "utf-8"), unicode("１日以内", "utf-8"), unicode("３日以内", "utf-8"), unicode("７日以内", "utf-8"), unicode("14日以内", "utf-8"), unicode("30日以内", "utf-8")], CONF['setting_days'])),
(unicode("ファイル数制限","utf-8"), "combo",([unicode("制限なし", "utf-8"), unicode("5ﾌｧｲﾙまで", "utf-8"), unicode("10ﾌｧｲﾙまで", "utf-8"), unicode("30ﾌｧｲﾙまで", "utf-8"), unicode("50ﾌｧｲﾙまで", "utf-8"), unicode("100ﾌｧｲﾙまで", "utf-8")], CONF['setting_limit'])),
(unicode("ATT1調整方法","utf-8"), "combo",([unicode("調整なし", "utf-8"), unicode("N82/ﾍｯﾀﾞを調整する", "utf-8"), unicode("拡張子をhtmlにする", "utf-8"), unicode("N73/ﾍｯﾀﾞ＆拡張子調整", "utf-8")], CONF['setting_att1'])),
(unicode("ﾀｲﾑｽﾀﾝﾌﾟ取得","utf-8"), "combo",([unicode("しない(日数,ｿｰﾄ無効)", "utf-8"), unicode("する", "utf-8")], CONF['setting_ts'])),
(unicode("ｿｰﾄ（ver1.9.x用）","utf-8"), "combo",([unicode("しない", "utf-8"), unicode("する（降順）", "utf-8"), unicode("する（昇順）", "utf-8")], CONF['setting_sort'])),
], appuifw.FFormDoubleSpaced)
    form.execute()
    # 設定情報更新
    index = 0
    for f in form:
        # 検索ドライブ
        if index == 0:
            CONF['setting_drive'] = int(f[2][1])
            if os.path.isdir(CONF['drives'][CONF['setting_drive']] + "\\Private\\1000484b\\Mail2\\00001001_S") == True:
                CONF['mail_dir'] = CONF['drives'][CONF['setting_drive']] + "\\Private\\1000484b\\Mail2\\00001001_S"

        # 日数制限
        if index == 1:
            CONF['setting_days']  = int(f[2][1])
            CONF['hour_ago'] = 24 * DAYS_AGO_MASTER[CONF['setting_days']]

        # ファイル数制限
        if index == 2:
            CONF['setting_limit'] = int(f[2][1])
            CONF['file_limit'] = FILE_LIMIT_MASTER[CONF['setting_limit']]

        # ATT1調整方法
        if index == 3:
            CONF['setting_att1']  = int(f[2][1])

        # ﾀｲﾑｽﾀﾝﾌﾟ取得
        if index == 4:
            CONF['setting_ts']  = int(f[2][1])
            if CONF['setting_ts'] == 1:
                CONF['file_get_ts'] = True
            else:
                CONF['file_get_ts'] = False

        # ｿｰﾄ（ver1.9.x用）
        if index == 5:
            CONF['setting_sort']  = int(f[2][1])
            if CONF['setting_sort'] >= 1 and CONF['ver19'] == True:
                CONF['file_sort'] = True
            else:
                CONF['file_sort'] = False

        index += 1

    # 設定保存
    saveConfig()

# アプリ終了
def appExit():
    lock.signal()
    sys.exit()

appuifw.app.menu = [
(unicode("検索開始","utf-8"), search),
(unicode("設定","utf-8"), setting),
(unicode("終了","utf-8"), appExit)
]
appuifw.app.exit_key_handler = lambda:lock.signal()
lock.wait()

# --- #
# EOF #
# --- #